/*
 * Copyright 2012 Leviathan.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package mx.com.leviathan.console;

import mx.com.leviathan.console.command.CommandPackage;
import mx.com.leviathan.console.event.ExitCommandListener;
import mx.com.leviathan.console.event.HelpCommandListener;
import mx.com.leviathan.console.event.RunCommandListener;
import mx.com.leviathan.console.io.ConsoleCommandLine;
import mx.com.leviathan.console.loader.CommandLoader;
import mx.com.leviathan.console.settings.Settings;
import org.yaml.snakeyaml.Yaml;

/**
 *
 * @author Leviathan
 */
public class Console {

    public Console() {
        CommandLoader.getInstance().init();
        ConsoleCommandLine commandLine = new ConsoleCommandLine();
        commandLine.getCommandLineListeners().add(new ExitCommandListener());
        commandLine.getCommandLineListeners().add(new HelpCommandListener());
        commandLine.getCommandLineListeners().add(new RunCommandListener());
        commandLine.start();
    }

    public static void main(String[] args) {
        Console console = new Console();
    }

    public void test() {
        Settings settings = Settings.getInstance(false);
        settings.getPackages().add(new CommandPackage("asd", new String[]{"asd", "asd"}, new String[]{"asd", "asd"}));
        System.out.println(new Yaml().dump(settings));
    }
}
