/*
 * Copyright 2012 Leviathan.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package mx.com.leviathan.console.command;

import java.util.Arrays;
import java.util.List;

/**
 *
 * @author Leviathan
 */
public class CommandRule {

    private String key;
    private List<Object> values;

    public CommandRule(String key, boolean required, Object... value) {
        this.key = key;
        if (required) {
            this.values = Arrays.asList(value);
        }
    }

    public List<Object> getValues() {
        return values;
    }

    public void setValues(List<Object> values) {
        this.values = values;
    }

    public boolean isValid(String key, Object value) {
        return (this.key != null ? this.key.equals(key) : false) ? (this.values != null ? (this.values.contains(value) ? true : false) : true) : false;
    }
}
