/*
 * Copyright 2012 Leviathan.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package mx.com.leviathan.console.event;

import java.util.HashMap;
import java.util.regex.Matcher;
import mx.com.leviathan.console.io.CommandLine;
import mx.com.leviathan.console.util.CommandUtils;
import mx.com.leviathan.console.util.RegexUtils;

/**
 *
 * @author Leviathan
 */
public class RunCommandListener implements CommandLineListener {

    @Override
    public boolean onInput(String line, CommandLine commandLine) {
        if (RegexUtils.match("(^[\\w]+$)", line)) {
            CommandUtils.runCommand(line, null);
            return true;
        } else if (RegexUtils.match("([\\w]+)[=]([\\w\\d\\.]+)", line)) {
            HashMap<String, Object> values = new HashMap<String, Object>();
            String name = line.split(" ", 2)[0];
            Matcher matcher = RegexUtils.matcher("([\\w]+)[=]([\\w\\d\\.]+)", line);
            while (matcher.find()) {
                values.put(matcher.group(1), matcher.group(2));
            }
            CommandUtils.runCommand(name, values);
            return true;
        } else if (RegexUtils.match("([\\w]+)[\\s]+([\\w\\d]+)", line)) {
            Matcher matcher = RegexUtils.matcher("([\\w]+)[\\s]+([\\w\\d]+)", line);
            matcher.find();
            String name = matcher.group(1);
            HashMap<String, Object> values = new HashMap<String, Object>();
            values.put(matcher.group(2), "");
            CommandUtils.runCommand(name, values);
            return true;
        }
        return false;
    }
}
