/*
 * Copyright 2012 Leviathan.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package mx.com.leviathan.console.template;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import mx.com.leviathan.commons.umi.template.Context;
import mx.com.leviathan.console.util.ContextUtils;
import mx.com.leviathan.console.util.FileUtils;
import mx.com.leviathan.console.util.TemplateUtils;

/**
 *
 * @author Leviathan
 */
public class TemplateBuilder {

    private List<String[]> templates = new ArrayList<String[]>();

    public void add(String template, String directory, String fileName) {
        templates.add(new String[]{template, directory, fileName});
    }

    public boolean build(Map<String, Object> values) {
        for (String[] data : templates) {
            if (!FileUtils.makeDir(data[1])) {
                return false;
            }
            Context context = ContextUtils.build(values);
            try {
                TemplateUtils.build(data[0], context).saveFile(new File(data[1] + data[2]));
            } catch (Exception ex) {
                Logger.getLogger(TemplateBuilder.class.getName()).log(Level.SEVERE, null, ex);
                return false;
            }
        }
        return true;
    }
}
