/*
 * Copyright 2012 Leviathan.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package mx.com.leviathan.console.util;

import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import mx.com.leviathan.commons.umi.template.Context;
import mx.com.leviathan.commons.umi.template.DocumentBuilder;
import mx.com.leviathan.commons.umi.template.Template;
import mx.com.leviathan.commons.umi.template.TemplateLoader;
import mx.com.leviathan.console.settings.Settings;

/**
 *
 * @author Leviathan
 */
public class TemplateUtils {

    public static DocumentBuilder build(String templateName, Context context) {
        String templatePath = Settings.getInstance(false).getOptions().get("template_path").toString();
        File templateFile = new File(templatePath + templateName);
        if (templateFile.exists()) {
            Template template = TemplateLoader.getTemplate(new Template(templateFile));
            try {
                return template.render(context);
            } catch (IOException ex) {
                Logger.getLogger(TemplateUtils.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        return null;
    }
}
