/*
 * Copyright 2012 Leviathan.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package mx.com.leviathan.console.util;

import java.io.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

/**
 *
 * @author Leviathan
 */
public class ZipUtils {

    public static void unzip(String zip, String out, int buffer) {
        try {
            BufferedOutputStream bufferedOutputStream = null;
            FileInputStream fileInputStream = new FileInputStream(zip);
            ZipInputStream zipInputStream = new ZipInputStream(new BufferedInputStream(fileInputStream));
            ZipEntry entry;
            int count;
            byte data[] = new byte[buffer];
            while ((entry = zipInputStream.getNextEntry()) != null) {
                System.out.println("Extracting: " + entry);
                String route = entry.getName().replace("ZanPHP/", "");
                int index = route.indexOf("/");
                route = route.substring(index + 1);
                if (route.trim().length() > 0) {
                    try {
                        bufferedOutputStream = null;
                        File file = new File(out + entry.getName().replace("ZanPHP/", ""));
                        if (entry.isDirectory()) {
                            file.mkdirs();
                        } else {
                            if (file.getParentFile().exists() == false) {
                                file.getParentFile().mkdirs();
                            }
                            FileOutputStream fileOutputStream = new FileOutputStream(file);
                            bufferedOutputStream = new BufferedOutputStream(fileOutputStream, buffer);
                            while ((count = zipInputStream.read(data, 0, buffer)) != -1) {
                                bufferedOutputStream.write(data, 0, count);
                            }
                            bufferedOutputStream.flush();
                        }
                    } finally {
                        try {
                            if (bufferedOutputStream != null) {
                                bufferedOutputStream.close();
                            }
                        } catch (Exception ex) {
                            Logger.getLogger(ZipUtils.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }
                }
            }
            zipInputStream.close();
        } catch (Exception ex) {
            Logger.getLogger(ZipUtils.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
